function AnhydReactRate(I,J,K,Tempr,Presr,Salin) result(Answer)
! purpose: calculate the reaction rate of anhydrite (mol/(m^3 s))
! input: node indices, temperature (C), pressure (Pa), and 
!        salinity (mass fraction NaCl)

use CommonVars, only: Prec,Temp
implicit none
real(selected_real_kind(Prec)) :: Answer,UdotGradT,SolAnhydrite,    &
   Tempr,Presr,Salin,Dens,CalcBulkDens
integer :: I,J,K

Dens = CalcBulkDens(Tempr,Presr,Salin)
Answer = Dens*SolAnhydrite(Tempr)*UdotGradT(I,J,K,Tempr)
end
