function CalcHaliteSat(Temp,Pres,Sali) result(Answer)

use CommonVars, only: Prec,DensSlices,HaliteDens
implicit none
real(selected_real_kind(Prec)) :: Temp,Pres,Sali,Answer,Sal3PhL, &
   Sal3PhV,Den3PhL,Den3PhV,Alpha,Beta,Pres3Phase,Interp3D,       &
   RefPres,RefTemp,HalRefDens,Term1,Term2,SolubilityV,HalDens,   &
   S3PhaseL
integer :: PhaseInd,PhaseIndex

PhaseInd = PhaseIndex(Pres,Temp,Sali)
if (PhaseInd == -2) then
   ! liquid + halite
   Sal3PhL = S3PhaseL(Temp)
   Den3PhL = Interp3D(Temp,Pres,Sal3PhL,DensSlices)
   Alpha = 1.D-4
   Beta  = 1.D-1
   RefPres = Pres3Phase(Temp)
   RefTemp = 0.D0
   HalRefDens = HaliteDens
   HalDens = HalRefDens+(Alpha*(Pres-RefPres)- &
                          Beta*(Temp-RefTemp))
   Term1 = Den3PhL*(Sali-Sal3PhL)
   Term2 = HalDens*(1.D0-Sali)
   Answer = Term1/(Term1+Term2)
elseif (PhaseInd == 2) then
   ! vapor + halite
   Sal3PhV = SolubilityV(Temp)
   Den3PhV = Interp3D(Temp,Pres,Sal3PhV,DensSlices)
   Alpha = 1.D-4
   Beta  = 1.D-1
   RefPres = Pres3Phase(Temp)
   RefTemp = 0.D0
   HalRefDens = HaliteDens
   HalDens = HalRefDens+(Alpha*(Pres-RefPres)- &
                          Beta*(Temp-RefTemp))
   Term1 = Den3PhV*(Sali-Sal3PhV)
   Term2 = HalDens*(1.D0-Sali)
   Answer = Term1/(Term1+Term2)
else
   Answer = 0.0
end if
end
