subroutine CalcL2Norm(L2NormP,L2NormT,L2NormX)

use CommonVars, only: Prec,Residual,NumNodesTotal,Temp,Pres,  &
   Sali,GridIndMat,PresNodeTypes,TempNodeTypes,SaliNodeTypes
implicit none
real(selected_real_kind(Prec)) :: L2NormP,PresResid,TempResid, &
   L2NormT,L2NormX,SaliResid
integer :: L,I,J,K

L2NormP = 0.D0
L2NormT = 0.D0
L2NormX = 0.D0
do L=1,NumNodesTotal
   I = GridIndMat(L,1)
   J = GridIndMat(L,2)
   K = GridIndMat(L,3)

   if (PresNodeTypes(I,J,K).ne.'C') then
      Residual(L) = PresResid(L,'N')
   else
      Residual(L) = 0.D0
   end if
   L2NormP = L2NormP + Residual(L)**2.D0

   if ((TempNodeTypes(I,J,K).ne.'C').and. &
       (TempNodeTypes(I,J,K).ne.'U')) then
      Residual(L+NumNodesTotal) = TempResid(L,'N')
   else
      Residual(L+NumNodesTotal) = 0.D0
   end if
   L2NormT = L2NormT + (Residual(L+NumNodesTotal)/1.D3)**2.D0

   if ((SaliNodeTypes(I,J,K).ne.'C').and. &
       (SaliNodeTypes(I,J,K).ne.'U')) then
      Residual(L+2*NumNodesTotal) = SaliResid(L)
   else
      Residual(L+2*NumNodesTotal) = 0.D0
   end if
   L2NormX = L2NormX + Residual(L+2*NumNodesTotal)**2.D0
end do
L2NormP = sqrt(L2NormP)
L2NormT = sqrt(L2NormT)
L2NormX = sqrt(L2NormX)
end
