subroutine CalcL2NormStress(L2NormX,L2NormZ)

use CommonVars, only: Prec,StressResidual,NumNodesTotal,DispX, &
   DispZ,GridIndMat,StressNodeTypes
implicit none
real(selected_real_kind(Prec)) :: L2NormX,L2NormZ,DispXResid,  &
   DispZResid
integer :: L,I,J,K

L2NormX = 0.D0
L2NormZ = 0.D0
do L=1,NumNodesTotal
   I = GridIndMat(L,1)
   J = GridIndMat(L,2)
   K = GridIndMat(L,3)

   if (StressNodeTypes(I,J,K).ne.'P') then
      StressResidual(L) = DispXResid(L)
   else
      StressResidual(L) = 0.D0
   end if
   L2NormX = L2NormX + StressResidual(L)**2.D0

   if (StressNodeTypes(I,J,K).ne.'P') then
      StressResidual(L+NumNodesTotal) = DispZResid(L)
   else
      StressResidual(L+NumNodesTotal) = 0.D0
   end if
   L2NormZ = L2NormZ + (StressResidual(L+NumNodesTotal)/1.D3)**2.D0
end do
L2NormX = sqrt(L2NormX)
L2NormZ = sqrt(L2NormZ)
!write(*,*) L2NormX,L2NormZ
!stop
end
