subroutine CalcMaxNorms

use CommonVars, only: Prec,MaxMassResid,Residual,Temp,             &
   Pres,Sali,NumNodesTotal,GridIndMat,MaxMassResidPos,Corrections, &
   PresNodeTypes,TempNodeTypes,MaxEnergyResid,MaxEnergyResidPos,   &
   MaxSaltResidPos,MaxSaltResid,LogFile,XNodeWidths,YNodeWidths,   &
   ZNodeWidths,Delta_t,SaliNodeTypes
implicit none
real(selected_real_kind(Prec)) :: PresResid,TempResid,SaliResid,   &
   MassIn,EnergyIn,SaltIn
integer :: L,I,J,K

! calculate the maximum mass balance residual
MaxMassResid = 0.D0
do L=1,NumNodesTotal
   I = GridIndMat(L,1)
   J = GridIndMat(L,2)
   K = GridIndMat(L,3)

   if (PresNodeTypes(I,J,K).ne.'C') then
      Residual(L) = PresResid(L,'N')
   else
      Residual(L) = 0.D0
   end if

   if (DABS(Residual(L))>MaxMassResid) then
      MaxMassResid = dabs(Residual(L))
      MaxMassResidPos(1) = I
      MaxMassResidPos(2) = J
      MaxMassResidPos(3) = K
   end if
end do
MaxEnergyResid = 0.D0
do L=1,NumNodesTotal
   I = GridIndMat(L,1)
   J = GridIndMat(L,2)
   K = GridIndMat(L,3)

   if ((TempNodeTypes(I,J,K).ne.'C').and. &
       (TempNodeTypes(I,J,K).ne.'U')) then
      Residual(L+NumNodesTotal) = TempResid(L,'N')
   else
      Residual(L+NumNodesTotal) = 0.D0
   end if

   if (DABS(Residual(L+NumNodesTotal))>MaxEnergyResid) then
      MaxEnergyResid = dabs(Residual(L+NumNodesTotal))
      MaxEnergyResidPos(1) = I
      MaxEnergyResidPos(2) = J
      MaxEnergyResidPos(3) = K
   end if
end do
MaxSaltResid = 0.D0
do L=1,NumNodesTotal
   I = GridIndMat(L,1)
   J = GridIndMat(L,2)
   K = GridIndMat(L,3)

   if ((SaliNodeTypes(I,J,K).ne.'C').and. &
      (SaliNodeTypes(I,J,K).ne.'U')) then
      Residual(L+2*NumNodesTotal) = &
         SaliResid(L)
   else
      Residual(L+2*NumNodesTotal) = 0.D0
   end if

   if (DABS(Residual(L+2*NumNodesTotal))>MaxSaltResid) then
      MaxSaltResid = dabs(Residual(L+2*NumNodesTotal))
      MaxSaltResidPos(1) = I
      MaxSaltResidPos(2) = J
      MaxSaltResidPos(3) = K
   end if
end do
end
