function CalcPoros(NodeNumber,Tempr,Presr,Salin) result(Answer)
! purpose: calculate the porosity as a function of node
!          number, temperature (C), pressure (Pa) and 
!          salinity (wt.fraction NaCl), constant at present 
!          but can be modified in future
use CommonVars, only: Prec,GridIndMat,Porosities,OldPoros,Delta_t, &
   InitPorosities
implicit none
real(selected_real_kind(Prec)) :: Answer,Tempr,Presr,Salin,        &
   AnhydReactRate,AnhydMolMass,CalcBulkDens,Dens,R,MinTempr,       &
   MaxTempr
integer :: I,J,K,NodeNumber

I = GridIndMat(NodeNumber,1)
J = GridIndMat(NodeNumber,2)
K = GridIndMat(NodeNumber,3)

MinTempr = 150.0
MaxTempr = 300.0

Answer = OldPoros(I,J,K)
end
