subroutine CalcSalin(I,J,K,Salin)
! Purpose: To calculate the QS term in the salinity equation.
! Input: Node indices I,J,K
! Output: Salin, the source term for the salinity equation.

use CommonVars, only: Prec,XNodeWidths,YNodeWidths,ZNodeWidths,      &
   OldPoros,OldSali,Delta_t,OldDens
implicit none
real (selected_real_kind(Prec)) :: Salin,TotalSalt,TotalMass,        &
   TotalVolume,TotalMassIn,TotalSaltIn,MassIn,SaltIn
integer :: I,J,K

TotalVolume = XNodeWidths(I)*YNodeWidths(J)*ZNodeWidths(K)

TotalMassIn = MassIn(I,J,K)
TotalSaltIn = SaltIn(I,J,K)

TotalSalt = OldDens(I,J,K)*OldSali(I,J,K)*OldPoros(I,J,K)* &
            TotalVolume + TotalSaltIn
TotalMass = OldDens(I,J,K)*OldPoros(I,J,K)*TotalVolume + &
            TotalMassIn
Salin = TotalSalt/TotalMass
end
