subroutine CalcStrain

use CommonVars, only: Prec,DispX,DispZ,StrainXX,StrainZZ,StrainXZ,  &
   NumNodesX,NumNodesY,NumNodesZ,XNodeWidths,ZNodeWidths
implicit none
real(selected_real_kind(Prec)) :: NodeDistPE,NodeDistPW,NodeDistPB, &
   NodeDistPT,NodeDistWE,NodeDistTB,ZDerivDispX(NumNodesX,          &
   NumNodesY,NumNodesZ),XDerivDispZ(NumNodesX,NumNodesY,NumNodesZ)
 
integer :: I,J,K

do I=1,NumNodesX
   do J=1,NumNodesY
      do K=1,NumNodesZ
         if ((I>1).and.(I<NumNodesX)) then
            NodeDistWE = XNodeWidths(I-1)/2.D0 + &
                         XNodeWidths(I) + XNodeWidths(I+1)/2.D0
            StrainXX(I,J,K) = (DispX(I+1,J,K)-DispX(I-1,J,K))/ &
               NodeDistWE
            XDerivDispZ(I,J,K) = (DispZ(I+1,J,K)-DispZ(I-1,J,K))/ &
               NodeDistWE
         elseif (I==1) then
            NodeDistPE = XNodeWidths(I)/2.D0 + &
                         XNodeWidths(I+1)/2.D0
            StrainXX(I,J,K) = (DispX(I+1,J,K)-DispX(I,J,K))/ &
               NodeDistPE
            XDerivDispZ(I,J,K) = (DispZ(I+1,J,K)-DispZ(I,J,K))/ &
               NodeDistPE
         elseif (I==NumNodesX) then
            NodeDistPW = XNodeWidths(I)/2.D0 + &
                         XNodeWidths(I-1)/2.D0
            StrainXX(I,J,K) = (DispX(I,J,K)-DispX(I-1,J,K))/ &
               NodeDistPW
            XDerivDispZ(I,J,K) = (DispZ(I,J,K)-DispZ(I-1,J,K))/ &
               NodeDistPW
         end if
         if ((K>1).and.(K<NumNodesZ)) then
            NodeDistTB = ZNodeWidths(K-1)/2.D0 + &
                         ZNodeWidths(K) + ZNodeWidths(K+1)/2.D0
            StrainZZ(I,J,K) = (DispZ(I,J,K+1)-DispZ(I,J,K-1))/ &
               NodeDistTB
            ZDerivDispX(I,J,K) = (DispX(I,J,K+1)-DispX(I,J,K-1))/ &
               NodeDistTB 
         elseif (K==1) then
            NodeDistPB = ZNodeWidths(K)/2.D0 + &
                         ZNodeWidths(K+1)/2.D0
            StrainZZ(I,J,K) = (DispZ(I,J,K+1)-DispZ(I,J,K))/ &
               NodeDistPB
            ZDerivDispX(I,J,K) = (DispX(I,J,K+1)-DispZ(I,J,K))/ &
               NodeDistPB
         elseif (K==NumNodesZ) then
            NodeDistPT = ZNodeWidths(K)/2.D0 + &
                         ZNodeWidths(K-1)/2.D0
            StrainZZ(I,J,K) = (DispZ(I,J,K)-DispZ(I,J,K-1))/ &
               NodeDistPT
            ZDerivDispX(I,J,K) = (DispX(I,J,K)-DispX(I,J,K-1))/ &
               NodeDistPT
         end if
         StrainXZ(I,J,K) = (1.D0/2.D0)*(ZDerivDispX(I,J,K) + &
            XDerivDispZ(I,J,K))
      end do
   end do
end do
end
