function ChkNeighborExist(NodeNumber,Face) result(Answer)
! purpose: to check whether there is a neighboring control volume
!          on a specified side of that volume
! input: the number of the node whose neighboring node is sought;
!        Face = 'W','E','T','B' indicating the West, East, Top, or
!        Bottom interface
! output: 0 if the is no such neighboring node; 1 otherwise

use CommonVars, only: Prec,GridIndMat,NumNodesX,NumNodesZ
implicit none
integer :: NodeNumber,Answer,I,J,K,NodeExist
character :: Face

I = GridIndMat(NodeNumber,1)
J = GridIndMat(NodeNumber,2)
K = GridIndMat(NodeNumber,3)

NodeExist = 1
if ((Face=='W').and.(I==1)) then
   NodeExist = 0
elseif ((Face=='E').and.(I==NumNodesX)) then
   NodeExist = 0
elseif ((Face=='T').and.(K==1)) then
   NodeExist = 0
elseif ((Face=='B').and.(K==NumNodesZ)) then
   NodeExist = 0
end if
Answer = NodeExist
end
