subroutine InterfHeatFlux

use CommonVars, only: Prec,NumNodesX,NumNodesY,NumNodesZ,           &
   LiqVelocX,LiqVelocZ,VapVelocX,VapVelocZ,XInterfVapDens,          &
   XInterfLiqDens,ZInterfLiqDens,ZInterfVapDens,XInterfHeatFlux,    &
   ZInterfHeatFlux,XInterfLiqEnth,XInterfVapEnth,ZInterfLiqEnth,    &
   ZInterfVapEnth,OldTemp,Delta_t,PhaseIndices
implicit none
integer :: I,J,K
real(selected_real_kind(Prec)) :: DeltaPres,NodeDist,PresGrad

!--------------------------------------------------------------------
! heat fluxes in the x direction
!--------------------------------------------------------------------
do I=1,NumNodesX-1
   do J=1,NumNodesY
      do K=1,NumNodesZ
         XInterfHeatFlux(I,J,K) = &
            VapVelocX(I,J,K)*XInterfVapDens(I,J,K)* &
            XInterfVapEnth(I,J,K) + &
            LiqVelocX(I,J,K)*XInterfLiqDens(I,J,K)* &
            XInterfLiqEnth(I,J,K)
      end do
   end do
end do
!--------------------------------------------------------------------
! heat fluxes in the z direction
!--------------------------------------------------------------------
do I=1,NumNodesX
   do J=1,NumNodesY
      do K=1,NumNodesZ-1
         ZInterfHeatFlux(I,J,K) = &
            VapVelocZ(I,J,K)*ZInterfVapDens(I,J,K)* &
            ZInterfVapEnth(I,J,K) + &
            LiqVelocZ(I,J,K)*ZInterfLiqDens(I,J,K)* &
            ZInterfLiqEnth(I,J,K)
         !if (K<50) then
         !   write(*,*) K,ZInterfHeatFlux(I,J,K)
         !end if
      end do
   end do
end do

end
