subroutine Invert3Mat(A,InvA,Singular)
! Given a 3x3 matrix A, returns the inverse InvA of this matrix
! Singular is returned with 1 if the matrix is singular, 0 otherwise

use CommonVars, only: Prec,LogFile
implicit none
integer :: I,J,Singular
real(selected_real_kind(Prec)) :: A(3,3),InvA(3,3),determ(3,3),detA, &
   Tol

determ(1,1) = A(2,2)*A(3,3)-A(2,3)*A(3,2)
determ(1,2) = A(1,3)*A(3,2)-A(1,2)*A(3,3)
determ(1,3) = A(1,2)*A(2,3)-A(1,3)*A(2,2)
determ(2,1) = A(2,3)*A(3,1)-A(2,1)*A(3,3)
determ(2,2) = A(1,1)*A(3,3)-A(1,3)*A(3,1)
determ(2,3) = A(1,3)*A(2,1)-A(1,1)*A(2,3)
determ(3,1) = A(2,1)*A(3,2)-A(2,2)*A(3,1)
determ(3,2) = A(1,2)*A(3,1)-A(1,1)*A(3,2)
determ(3,3) = A(1,1)*A(2,2)-A(1,2)*A(2,1)

detA = A(1,1)*determ(1,1) + A(1,2)*determ(2,1) + A(1,3)*determ(3,1)

Tol = 1.D-9
if (DABS(detA) < Tol) then
   Singular = 1
else
   Singular = 0
   do I=1,3
     do J=1,3
       InvA(I,J) = (1.D0/detA)*determ(I,J)
     end do
   end do
end if

end
