subroutine MatrixMult(A,NumRowsA,NumColsA,B,NumRowsB,NumColsB,C)

use CommonVars, only: Prec,LogFile
implicit none
integer :: NumRowsA,NumColsA,NumRowsB,NumColsB,I,J,K
real(selected_real_kind(Prec)) :: A(NumRowsA,NumColsA),B(NumRowsB,NumColsB), &
   C(NumRowsA,NumColsB)

if (NumColsA.ne.NumRowsB) then
   write(LogFile,*) 'Matrix dimensions are incompatible -MatrixMult'
   stop
end if

do I=1,NumRowsA
   do J=1,NumColsB
     C(I,J) = 0.D0
     do K=1,NumColsA
        C(I,J) = C(I,J) + A(I,K)*B(K,J)
     end do
   end do
end do

end
