subroutine PseudoInv(A,PseudoInvA)
! Given a 4x3 matrix A, returns the pseudo-inverse of this matrix

use CommonVars, only: Prec,LogFile
implicit none
integer :: I,J,Singular
real(selected_real_kind(Prec)) :: A(4,3),PseudoInvA(3,4),TransA(3,4), &
   C(3,3),InvC(3,3)

! compute the transpose of A
do I=1,3
   do J=1,4
      TransA(I,J) = A(J,I)
   end do
end do

! form the matrix trans(A)*A
call MatrixMult(TransA,3,4,A,4,3,C)

! invert trans(A)*A
call Invert3Mat(C,InvC,Singular)
!if (Singular==1) then
!   write(LogFile,*) 'Singular matrix! -PseudoInv'
!   stop
!end if

! form the matrix inv[trans(A)*A)]*trans(A) - this is the matrix
! pseudo-inverse
call MatrixMult(InvC,3,3,TransA,3,4,PseudoInvA)

end
