function RelativeDirection(Node1,Node2) result(Answer)
! purpose: output the direction of Node2 relative to Node1
! input: nodes with numbers Node1 and Node2

! ConnectMat(M,1) = node number of the west   neighbor of node M
! ConnectMat(M,2) = node number of the east   neighbor of node M
! ConnectMat(M,3) = node number of the top    neighbor of node M
! ConnectMat(M,4) = node number of the bottom neighbor of node M
! ConnectMat(M,5) = node number of the north  neighbor of node M
! ConnectMat(M,6) = node number of the south  neighbor of node M
! -1 will be stored when the neighboring node does not exist

use CommonVars, only: Prec,ConnectMat,LogFile
implicit none
integer :: Node1,Node2
character :: Answer

if (Node2==ConnectMat(Node1,1)) then
   Answer = 'W'
elseif (Node2==ConnectMat(Node1,2)) then
   Answer = 'E'
elseif (Node2==ConnectMat(Node1,3)) then
   Answer = 'T'
elseif (Node2==ConnectMat(Node1,4)) then
   Answer = 'B'
else
   write(LogFile,*) 'Nodes 1 and 2 not connected! -RelativeDirection'
   stop
end if

end
