function SaliResid(NodeNumber)  result(Answer)
! purpose: calculate the local salt balance residual
! input: NodeNumber = node at which to calculate the residual

use CommonVars, only: Prec,Delta_t,Temp,Pres,Sali,OldTemp,OldPres, &
   OldSali,GridIndMat,XNodeWidths,YNodeWidths,ZNodeWidths
implicit none
real(selected_real_kind(Prec)) :: Answer,SaltAccum,Accum,SaltIn,   &
  Volume
integer :: NodeNumber,I,J,K

I = GridIndMat(NodeNumber,1)
J = GridIndMat(NodeNumber,2)
K = GridIndMat(NodeNumber,3)

Accum =  SaltAccum(NodeNumber,Temp(I,J,K),Pres(I,J,K), &
         Sali(I,J,K)) - &
         SaltAccum(NodeNumber,OldTemp(I,J,K),OldPres(I,J,K), &
         OldSali(I,J,K))
Volume = XNodeWidths(I)*YNodeWidths(J)*ZNodeWidths(K)
Accum = Accum*Volume

Answer = ((Accum - SaltIn(I,J,K))/(Volume*Delta_t))*3.2e7
end
