function SaltAccum(NodeNumber,Tempr,Presr,Salin) result(Answer)
! purpose: calculate the term of which the time derivative is
!          taken in the salt balance equation (phi*rho*X)
! input: NodeNumber = node at which to calculate this value
!        Tempr = temperature(C); Presr = pressure (Pa);
!        Salin = salinity(wt.fraction NaCl)

use CommonVars, only: Prec
implicit none
real(selected_real_kind(Prec)) :: Tempr,Presr,Salin,Answer,CalcPoros, &
   CalcBulkDens,Poros,Dens
integer :: NodeNumber

Poros = CalcPoros(NodeNumber,Tempr,Presr,Salin)
Dens  = CalcBulkDens(Tempr,Presr,Salin)
Answer = Poros*Dens*Salin
end
