subroutine SolveSalinity
! Purpose: To solve the salinity equation

use CommonVars, only: NumNodesX,NumNodesY,NumNodesZ,SaliNodeTypes,  &
   Prec,OldSali,SaliBoundVals,ZInterfSaltFlux,Sali
implicit none
real (selected_real_kind(Prec)) :: Flux,Salin
integer :: I,J,K

do I=1,NumNodesX
   do J=1,NumNodesY
      do K=1,NumNodesZ
         if ((SaliNodeTypes(I,J,K)=='I').or. &
            (SaliNodeTypes(I,J,K)=='F')) then
            call CalcSalin(I,J,K,Salin)
            Sali(I,J,K)= Salin
         elseif (SaliNodeTypes(I,J,K)=='C') then
            Sali(I,J,K) = SaliBoundVals(I,J,K)
         elseif (SaliNodeTypes(I,J,K)=='U') then
            Flux = ZInterfSaltFlux(I,J,K)
            if (Flux<0.D0) then
               Sali(I,J,K)=OldSali(I,J,K+1)
            elseif (Flux>0.D0) then
               Sali(I,J,K)=SaliBoundVals(I,J,K)
            else
               Sali(I,J,K)=OldSali(I,J,K)
            end if
         end if
      end do
   end do
end do

end
