subroutine TestCorner
! Purpose: generate plot files for checking that CornerDisp
!          works properly.

use CommonVars, only: Prec,DispX,TWDispX,TEDispX,BWDispX,BEDispX, &
   NumNodesX,NumNodesY,NumNodesZ,XNodeWidths,ZNodeWidths
implicit none
real(selected_real_kind(Prec)) :: XCoord(NumNodesX,NumNodesY, &
   NumNodesZ),ZCoord(NumNodesX,NumNodesY,NumNodesZ),NodeDist
integer :: I,J,K

! assign x,z coords to every control volume node
do K=1,NumNodesZ
   do J=1,NumNodesY
      do I=1,NumNodesX
         if (I==1) then
            XCoord(I,J,K) = XNodeWidths(I)/2.D0
         else
            NodeDist = XNodeWidths(I-1)/2.D0 + &
                       XNodeWidths(I)/2.D0
            XCoord(I,J,K) = XCoord(I-1,J,K) + NodeDist
         end if
      end do
   end do
end do
do I=1,NumNodesX
   do J=1,NumNodesY
      do K=1,NumNodesZ
         if (K==1) then
            ZCoord(I,J,K) = ZNodeWidths(K)/2.D0
         else
            NodeDist = ZNodeWidths(K-1)/2.D0 + &
                       ZNodeWidths(K)/2.D0
            ZCoord(I,J,K) = ZCoord(I,J,K-1) + NodeDist
         end if
      end do
   end do
end do
end
